// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "fmc_defs.h"
#include "global.h"

void doDistributeStmt(SgStatement *s)
{
    SgVarListDeclStmt *dist_stmt;
    int i;
    
    dist_stmt = isSgVarListDeclStmt(s);
    fm_assert(dist_stmt);
    for (i = 0; i < dist_stmt->numberOfVars(); i++) {
	SgExpression *var;
	
	var = dist_stmt->var(i);

	if (var->variant() == ARRAY_REF) {
	    SgArrayRefExp *a = isSgArrayRefExp(var);
	    int j;
	    
	    //
	    // verify the distribute specs
	    //
	    for (j = 0; j < a->numberOfSubscripts(); j++) {
		SgExpression *sub = a->subscript(j);
		
		switch (sub->variant()) {
		  case BLOCK_OP:
		  case STAR_RANGE:
		    break;
		  case CYCLIC_OP:
		    fm_error(currentStatement, "\
CYCLIC distribution not supported yet");
		    return;
		    break;
		  default:
		    fm_error(currentStatement, "\
Unknown distribute option: %s", sub->unparse());
		    return;
		}
	    }
	    exprMapSet(distributeMap, symbName(a), a);	    
	} else {
	    fm_internal_error("\
Expect array reference in a distribute statement (%s:%d) but get a %s",
			      __FILE__, __LINE__, 
			      getVariantByName(var->variant()));
	}
    }
    fmStmtSLL.append(s);
}

