// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#ifndef FM_PROG_BLOCK_DEFINED
#define FM_PROG_BLOCK_DEFINED

class FMProgBlock  {
    SgFile                          *theFile;
    char                            *file_name;
    char                            *file_base_name;
    SgStatement                     *theProc;
    char                            *proc_name;
    StringSgStatementAVLMap         *port_var_dict;
    StringSgExpressionAVLMap        *port_type_map;
    StringSgStatementAVLMap         *pros_map;
    StringSgStatementAVLMap         *pros_def_map;
    StringSgExpressionAVLMap        *pros_hedr_map;
    StringSgExpressionAVLMap        *intent_map;
    StringSgExpressionAVLMap        *processors_map;
    StringSgExpressionAVLMap        *parameter_map;
    StringSgExpressionAVLMap        *staticVar_map;
    StringSgExpressionAVLMap        *type_map;
    StringSgExpressionAVLMap        *distribute_map;
    StringSgStatementAVLMap         *mpcall_map;

  public:
    FMProgBlock();
    ~FMProgBlock();
    
    inline SgFile                         *file();
    inline char                           *fileName();
    inline char                           *fileBaseName();
    inline SgStatement                    *proc();
    inline char                           *procName();
    inline StringSgStatementAVLMap        *portVarDict();
    inline StringSgExpressionAVLMap       *portTypeMap();
    inline StringSgStatementAVLMap        *prosMap();
    inline StringSgStatementAVLMap        *prosDefMap();
    inline StringSgExpressionAVLMap       *prosHedrMap();
    inline StringSgExpressionAVLMap       *intentMap();
    inline StringSgExpressionAVLMap       *processorsMap();
    inline StringSgExpressionAVLMap       *parameterMap();
    inline StringSgExpressionAVLMap       *staticVarMap();
    inline StringSgExpressionAVLMap       *typeMap();
    inline StringSgExpressionAVLMap       *distributeMap();
    inline StringSgStatementAVLMap        *mpcallMap();

    inline void setFile             (SgFile *);
    inline void setFileName         (char *name);
    inline void setFileBaseName     (char *name);
    inline void setProc             (SgStatement *procHedr);
    inline void setProcName         (char *name);
    inline void setPortVarDict      (StringSgStatementAVLMap  *map);
    inline void setPortTypeMap      (StringSgExpressionAVLMap *map);
    inline void setProsMap          (StringSgStatementAVLMap  *map);
    inline void setProsDefMap       (StringSgStatementAVLMap  *map);
    inline void setProsHedrMap      (StringSgExpressionAVLMap *map);
    inline void setIntentMap        (StringSgExpressionAVLMap *map);
    inline void setProcessorsMap    (StringSgExpressionAVLMap *map);
    inline void setParameterMap     (StringSgExpressionAVLMap *map);
    inline void setStaticVarMap     (StringSgExpressionAVLMap *map);
    inline void setTypeMap          (StringSgExpressionAVLMap *map);
    inline void setDistributeMap    (StringSgExpressionAVLMap *map);
    inline void setMPcallMap        (StringSgStatementAVLMap  *map);

};

inline FMProgBlock::FMProgBlock()
{
    proc_name         = 0;
    port_var_dict     = 0;
    port_type_map     = 0;
    pros_map          = 0;
    pros_def_map      = 0;
    pros_hedr_map     = 0;
    intent_map        = 0;
    processors_map    = 0;
    parameter_map     = 0;
    staticVar_map     = 0;
    type_map          = 0;
    distribute_map    = 0;
    mpcall_map        = 0;
}

inline FMProgBlock::~FMProgBlock()
{}

inline SgFile *FMProgBlock::file()
{ return theFile; }

inline void FMProgBlock::setFile(SgFile *file)
{ theFile = file; }

inline char *FMProgBlock::fileName()
{ return file_name; }

inline void FMProgBlock::setFileName(char *name)
{ file_name = name; }

inline char *FMProgBlock::fileBaseName()
{ return file_base_name; }

inline void FMProgBlock::setFileBaseName(char *name)
{ file_base_name = name; }

inline SgStatement *FMProgBlock::proc()
{ return theProc; }

inline void FMProgBlock::setProc(SgStatement *proc)
{ theProc = proc; }

inline char *FMProgBlock::procName()
{ return proc_name; }

inline void FMProgBlock::setProcName(char *name)
{ proc_name = name; }

inline StringSgStatementAVLMap *FMProgBlock::portVarDict()
{ return port_var_dict; }

inline void FMProgBlock::setPortVarDict(StringSgStatementAVLMap *map)
{ port_var_dict = map; }

inline StringSgExpressionAVLMap *FMProgBlock::portTypeMap()
{ return port_type_map; }

inline void FMProgBlock::setPortTypeMap(StringSgExpressionAVLMap *map)
{ port_type_map = map; }

inline StringSgStatementAVLMap *FMProgBlock::prosMap()
{ return pros_map; }

inline void FMProgBlock::setProsMap(StringSgStatementAVLMap *map)
{ pros_map = map; }

inline StringSgStatementAVLMap *FMProgBlock::prosDefMap()
{ return pros_def_map; }

inline void FMProgBlock::setProsDefMap(StringSgStatementAVLMap *map)
{ pros_def_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::prosHedrMap()
{ return pros_hedr_map; }

inline void FMProgBlock::setProsHedrMap(StringSgExpressionAVLMap *map)
{ pros_hedr_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::intentMap()
{ return intent_map; }

inline void FMProgBlock::setIntentMap(StringSgExpressionAVLMap *map)
{ intent_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::processorsMap()
{ return processors_map; }

inline void FMProgBlock::setProcessorsMap(StringSgExpressionAVLMap *map)
{ processors_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::parameterMap()
{ return parameter_map; }

inline void FMProgBlock::setParameterMap(StringSgExpressionAVLMap *map)
{ parameter_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::staticVarMap()
{ return staticVar_map; }

inline void FMProgBlock::setStaticVarMap(StringSgExpressionAVLMap *map)
{ staticVar_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::typeMap()
{ return type_map; }

inline void FMProgBlock::setTypeMap(StringSgExpressionAVLMap *map)
{ type_map = map; }

inline StringSgExpressionAVLMap *FMProgBlock::distributeMap()
{ return distribute_map; }

inline void FMProgBlock::setDistributeMap(StringSgExpressionAVLMap *map)
{ distribute_map = map; }

inline StringSgStatementAVLMap *FMProgBlock::mpcallMap()
{ return mpcall_map; }

inline void FMProgBlock::setMPcallMap(StringSgStatementAVLMap *map)
{ mpcall_map = map; }

#endif /* FM_PROG_BLOCK_DEFINED */
