// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "fmc_defs.h"
#include "global.h"

void doProsCommStmt(SgStatement *s)
{
    SgNestedVarListDeclStmt *prosCommStmt = isSgNestedVarListDeclStmt(s);
    SgObjectListExp *commList;
    int i, j;

    if (! prosCommStmt) {
	fm_internal_error("\
statement passed to doProsCommonStmt is not of a SgNestedVarListDecclStmt: %s",
			  getVariantByName(s->variant()));
    }
    
    prosCommStmt->setVariant(COMM_STAT);
    doCommonStmt(prosCommStmt);
}

void doCommonStmt(SgStatement *s)
{
    SgNestedVarListDeclStmt *nd_stmt;
    
    int           i;
    int           j;

    if (opt_use_private_common) return;

    nd_stmt = isSgNestedVarListDeclStmt(s);

    for (i = 0; i < nd_stmt->numberOfLists(); i++) {
	SgObjectListExp *list;

	list = isSgObjectListExp(nd_stmt->list(i));

	fm_assert(list);

	for (j = 0; j < list->listLength(); j++) {
	    SgExpression *var = list->objectRef(j);

	    while (var->variant() == EXPR_LIST) {
		var = isSgExprListExp(var)->elem(0);
	    }
	    //
	    // put into current block's common list
	    //
	    stmtMapSet(prosMap, commonMapKeyEncode(symbName(var)), s);
	}
    }
}

void doCommonStmtsInProg(SgStatement *start, SgStatement *end)
{
    SgStatement *line;

    for (line = start; line != end; line = line->lexNext()) {
       switch (line->variant()) {
	 case PROS_COMM:
	   doProsCommStmt(line);
	   break;
	 case COMM_STAT:
	   if (! opt_allow_common) {
	       fm_error(line, "\
COMMON statements are not allowed, use -allow_common switch if you wish to treat COMMON statements as PROCESS COMMON statements");
	       continue;
	   }
	   doCommonStmt(line);
	   break;
//	 case DATA_DECL:
	   // treat data vars the same as
	   // COMMON vars, i.e. not automatic variables
//	   doDataDeclStmt(line);
//	   break;
	 default:
	   break;
       }
   }
}


    
