/*
 * internal.h
 *
 * rcsid = "$Header: /home/compose/Master/FM/src/nexus/internal.h,v 1.33 1995/08/22 20:31:29 tuecke Exp $"
 * nexus_rcsid = "Header: /Net/folding.compbio.caltech.edu/bcomp/src/master/nexus/internal.h,v 1.27 1995/06/13 16:50:33 geisler Exp "
 */

#define _NX_SYSTEM_COMPILE

#define NEXUS_USE_MACROS

#include "nexus.h"


#ifndef NEXUS_LITE
/*
 * Include the thread module's internal header, which should contain:
 *   1) #include's for any system headers needed internally for threads
 *   2) typedefs for internal nexus types
 *   3) macros for internal nexus routines
 */
#ifndef NEXUS_THI_HEADER
#define NEXUS_THI_HEADER "th_i.h"
#endif
#include NEXUS_THI_HEADER

#endif /* NEXUS_LITE */


/*
 * Now include all of the necessary system headers
 */
#include <stdio.h>
#include <ctype.h>
#include <errno.h>

#ifdef NEXUS_ARCH_NEXTSTEP
#include <libc.h>
#endif

#if defined(NEXUS_ARCH_SOLARIS) || defined(NEXUS_ARCH_AXPOSF) || \
	defined(NEXUS_ARCH_LINUX)
#include <unistd.h>
#endif

#ifdef NEXUS_ARCH_AXPOSF
#include <stdlib.h>
#include <sys/param.h>
#endif

#ifdef NEXUS_ARCH_SUNOS41
#include <malloc.h>
#include <unistd.h>
#include <sys/param.h>
#endif

#if defined(NEXUS_ARCH_AIX) 
#include <sys/param.h>
#include <sys/access.h>
#endif

#if defined(NEXUS_ARCH_LINUX) || defined(NEXUS_ARCH_FREEBSD)
#include <sys/param.h>
#endif

#ifdef NEXUS_ARCH_PARAGON
#include <sys/param.h>
#include <sys/access.h>
#include <sys/errno.h>
#define NEXUS_ARGS "NexusArgs" /* Environment variable */
#endif

#ifdef NEXUS_ARCH_SGI
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/param.h>
#endif

#ifdef NEXUS_ARCH_HPUX
#include <unistd.h>
#include <sys/types.h>
#include <sys/param.h>
#endif


/*
 * Now include the rest of the internal Nexus headers.
 */
#include "macros.h"
#include "types.h"
#include "funcs.h"
#include "globals.h"
#include "defs.h"
#ifdef NEXUS_PROFILE
#include "pablo.h"
#endif

